
CONST HGE_VERSION = 0x180

CONST M_PI   = 3.14159265358979323846
CONST M_PI_2 = 1.57079632679489661923
CONST M_PI_4 = 0.785398163397448309616
CONST M_1_PI = 0.318309886183790671538
CONST M_2_PI = 0.636619772367581343076

TYPEDEF HTEXTURE uint
TYPEDEF HTARGET uint
TYPEDEF HEFFECT uint
TYPEDEF HMUSIC uint
TYPEDEF HSTREAM uint
TYPEDEF HCHANNEL uint

TYPEDEF HFONT pointer
TYPEDEF HSPRITE pointer
TYPEDEF HANIMATION pointer
TYPEDEF HPARTSYS pointer
TYPEDEF HRECT pointer
TYPEDEF HCOLORRGB pointer
TYPEDEF HCOLORHSV pointer
TYPEDEF HDISTMESH pointer
TYPEDEF HVECTOR pointer

CONST BLEND_COLORADD = 1
CONST BLEND_COLORMUL = 0

CONST BLEND_ALPHABLEND = 2
CONST BLEND_ALPHAADD = 0

CONST BLEND_ZWRITE = 4
CONST BLEND_NOZWRITE = 0

CONST BLEND_DEFAULT = (BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_NOZWRITE)
CONST BLEND_DEFAULT_Z = (BLEND_COLORMUL | BLEND_ALPHABLEND | BLEND_ZWRITE)

TYPEDEF hgeBoolState INT
CONST	HGE_WINDOWED		= 1    
CONST	HGE_ZBUFFER			= 2    
CONST	HGE_TEXTUREFILTER	= 3    
CONST	HGE_USESOUND		= 4    
CONST	HGE_DONTSUSPEND		= 5    
CONST	HGE_HIDEMOUSE		= 6	 
CONST	HGE_SHOWSPLASH		= 7	
CONST	HGEBOOLSTATE_FORCE_DWORD = 0x7FFFFFFF

TYPEDEF hgeFuncState INT
CONST	HGE_FRAMEFUNC		 = 8   
CONST	HGE_RENDERFUNC		 = 9    
CONST	HGE_FOCUSLOSTFUNC	 = 10   
CONST	HGE_FOCUSGAINFUNC	 = 11   
CONST	HGE_GFXRESTOREFUNC 	 = 12   
CONST	HGE_EXITFUNC		 = 13  
CONST	HGEFUNCSTATE_FORCE_DWORD = 0x7FFFFFFF 

TYPEDEF hgeHwndState INT
CONST   HGE_HWND		 = 15
CONST	HGE_HWNDPARENT   = 16
CONST   HGEHWNDSTATE_FORCE_DWORD = 0x7FFFFFFF

TYPEDEF hgeIntState INT
CONST	HGE_SCREENWIDTH  = 17
CONST   HGE_SCREENHEIGHT = 18
CONST   HGE_SCREENBPP    = 19
CONST   HGE_SAMPLERATE   = 20
CONST   HGE_FXVOLUME     = 21
CONST   HGE_MUSVOLUME    = 22
CONST   HGE_FPS          = 23
CONST   HGE_POWERSTATUS	 = 24
CONST   HGEINTSTATE_FORCE_DWORD = 0x7FFFFFF

TYPEDEF hgeStringState INT
CONST	HGE_ICON    = 25
CONST   HGE_TITLE   = 26
CONST   HGE_INIFILE = 27
CONST   HGE_LOGFILE = 28
CONST   HGESTRINGSTATE_FORCE_DWORD = 0x7FFFFFFF        


CONST HGEFPS_UNLIMITED = 0
CONST HGEFPS_VSYNC = -1

CONST HGEPWR_AC = -1
CONST HGEPWR_UNSUPPORTED = -2

CONST HGEPRIM_LINES = 2
CONST HGEPRIM_TRIPLES = 3
CONST HGEPRIM_QUADS = 4

TYPE hgeVertex
	DEF x   AS float  
	DEF y   AS float  
	DEF z   AS float  
	DEF col AS uint    
	DEF tx  AS float  
	DEF ty  AS float  
ENDTYPE

TYPE hgeTriple
	DEF v[3]  AS hgeVertex
	DEF tex   AS uint   
	DEF blend AS INT    
ENDTYPE

TYPE hgeQuad 
	DEF v[4]  AS hgeVertex 
	DEF tex   AS HTEXTURE 
	DEF blend AS INT   
ENDTYPE

TYPE hgeRect
	DEF x1 AS float 
	DEF y1 AS float
	DEF x2 AS float
	DEF y2 AS float
ENDTYPE

Type hgeVector
	DEF x  AS float  
	DEF y  AS float   
ENDTYPE

TYPE hgeInputEvent
	DEF Typex   AS INT
	DEF Key 	AS INT
	DEF flags 	AS INT
	DEF Chr 	AS INT
	DEF wheel 	AS INT
	DEF x 		AS float
	DEF y 		AS float
ENDTYPE

CONST INPUT_KEYDOWN        	= 1
CONST INPUT_KEYUP          	= 2
CONST INPUT_MBUTTONDOWN    	= 3
CONST INPUT_MBUTTONUP      	= 4
CONST INPUT_MOUSEMOVE      	= 5
CONST INPUT_MOUSEWHEEL     	= 6

CONST HGEINP_SHIFT         	= 1
CONST HGEINP_CTRL          	= 2
CONST HGEINP_ALT           	= 4
CONST HGEINP_CAPSLOCK      	= 8
CONST HGEINP_SCROLLLOCK    	= 16
CONST HGEINP_NUMLOCK       	= 32
CONST HGEINP_REPEAT        	= 64

CONST HGETEXT_LEFT		   	= 0
CONST HGETEXT_RIGHT		   	= 1
CONST HGETEXT_CENTER	   	= 2
CONST HGETEXT_HORZMASK	    = 0x03

CONST HGETEXT_TOP			= 0
CONST HGETEXT_BOTTOM		= 4
CONST HGETEXT_MIDDLE		= 8
CONST HGETEXT_VERTMASK		= 0x0C

CONST HGEK_LBUTTON        	= 0x01
CONST HGEK_RBUTTON        	= 0x02
CONST HGEK_MBUTTON        	= 0x04

CONST HGEK_ESCAPE         	= 0x1B
CONST HGEK_BACKSPACE      	= 0x08
CONST HGEK_TAB            	= 0x09
CONST HGEK_ENTER          	= 0x0D
CONST HGEK_SPACE          	= 0x20
CONST HGEK_SHIFT          	= 0x10
CONST HGEK_CTRL           	= 0x11
CONST HGEK_ALT            	= 0x12
CONST HGEK_LWIN           	= 0x5B
CONST HGEK_RWIN           	= 0x5C
CONST HGEK_APPS           	= 0x5D
CONST HGEK_PAUSE          	= 0x13
CONST HGEK_CAPSLOCK       	= 0x14
CONST HGEK_NUMLOCK        	= 0x90
CONST HGEK_SCROLLLOCK     	= 0x91
CONST HGEK_PGUP           	= 0x21
CONST HGEK_PGDN           	= 0x22
CONST HGEK_HOME           	= 0x24
CONST HGEK_END            	= 0x23
CONST HGEK_INSERT         	= 0x2D
CONST HGEK_DELETE         	= 0x2E
CONST HGEK_LEFT           	= 0x25
CONST HGEK_UP             	= 0x26
CONST HGEK_RIGHT          	= 0x27
CONST HGEK_DOWN          	= 0x28
CONST HGEK_0             	= 0x30
CONST HGEK_1              	= 0x31
CONST HGEK_2              	= 0x32
CONST HGEK_3              	= 0x33
CONST HGEK_4              	= 0x34
CONST HGEK_5              	= 0x35
CONST HGEK_6              	= 0x36
CONST HGEK_7              	= 0x37
CONST HGEK_8              	= 0x38
CONST HGEK_9              	= 0x39
CONST HGEK_A              	= 0x41
CONST HGEK_B              	= 0x42
CONST HGEK_C              	= 0x43
CONST HGEK_D              	= 0x44
CONST HGEK_E              	= 0x45
CONST HGEK_F              	= 0x46
CONST HGEK_G              	= 0x47
CONST HGEK_H              	= 0x48
CONST HGEK_I              	= 0x49
CONST HGEK_J              	= 0x4A
CONST HGEK_K              	= 0x4B
CONST HGEK_L              	= 0x4C
CONST HGEK_M              	= 0x4D
CONST HGEK_N              	= 0x4E
CONST HGEK_O              	= 0x4F
CONST HGEK_P              	= 0x50
CONST HGEK_Q              	= 0x51
CONST HGEK_R              	= 0x52
CONST HGEK_S              	= 0x53
CONST HGEK_T              	= 0x54
CONST HGEK_U              	= 0x55
CONST HGEK_V              	= 0x56
CONST HGEK_W              	= 0x57
CONST HGEK_X              	= 0x58
CONST HGEK_Y              	= 0x59
CONST HGEK_Z              	= 0x5A
CONST HGEK_GRAVE          	= 0xC0
CONST HGEK_MINUS          	= 0xBD
CONST HGEK_EQUALS         	= 0xBB
CONST HGEK_BACKSLASH      	= 0xDC
CONST HGEK_LBRACKET       	= 0xDB
CONST HGEK_RBRACKET       	= 0xDD
CONST HGEK_SEMICOLON      	= 0xBA
CONST HGEK_APOSTROPHE     	= 0xDE
CONST HGEK_COMMA          	= 0xBC
CONST HGEK_PERIOD         	= 0xBE
CONST HGEK_SLASH          	= 0xBF
CONST HGEK_NUMPAD0        	= 0x60
CONST HGEK_NUMPAD1        	= 0x61
CONST HGEK_NUMPAD2        	= 0x62
CONST HGEK_NUMPAD3        	= 0x63
CONST HGEK_NUMPAD4        	= 0x64
CONST HGEK_NUMPAD5        	= 0x65
CONST HGEK_NUMPAD6        	= 0x66
CONST HGEK_NUMPAD7        	= 0x67
CONST HGEK_NUMPAD8        	= 0x68
CONST HGEK_NUMPAD9        	= 0x69
CONST HGEK_MULTIPLY       	= 0x6A
CONST HGEK_DIVIDE         	= 0x6F
CONST HGEK_ADD            	= 0x6B
CONST HGEK_SUBTRACT       	= 0x6D
CONST HGEK_DECIMAL        	= 0x6E
CONST HGEK_F1             	= 0x70
CONST HGEK_F2             	= 0x71
CONST HGEK_F3             	= 0x72
CONST HGEK_F4             	= 0x73
CONST HGEK_F5             	= 0x74
CONST HGEK_F6             	= 0x75
CONST HGEK_F7             	= 0x76
CONST HGEK_F8             	= 0x77
CONST HGEK_F9             	= 0x78
CONST HGEK_F10            	= 0x79
CONST HGEK_F11            	= 0x7A
CONST HGEK_F12            	= 0x7B


CONST HGEANIM_FWD			= 0
CONST HGEANIM_REV			= 1
CONST HGEANIM_PINGPONG		= 2
CONST HGEANIM_NOPINGPONG	= 0
CONST HGEANIM_LOOP		    = 4
CONST HGEANIM_NOLOOP		= 0

CONST HGEDISP_NODE		    = 0
CONST HGEDISP_TOPLEFT		= 1
CONST HGEDISP_CENTER		= 2

CONST HGESLIDER_BAR			= 0
CONST HGESLIDER_BARRELATIVE	= 1
CONST HGESLIDER_SLIDER		= 2

CONST HGEGUI_NONAVKEYS		= 0
CONST HGEGUI_LEFTRIGHT		= 1
CONST HGEGUI_UPDOWN			= 2
CONST HGEGUI_CYCLED			= 4

