
' USE THE IMPORT LIBRARY
$USE "ebhge.lib"


' SYSTEM FUNCTIONS
DECLARE CDECL IMPORT, hge_Create(version as INT),INT
DECLARE CDECL IMPORT, hge_System_SetStateFunc(hgeFuncState state, INT func)
DECLARE CDECL IMPORT, hge_System_SetStateString(hgeStringState state, STRING value)
DECLARE CDECL IMPORT, hge_System_SetStateBool(hgeBoolState state, INT value)
DECLARE CDECL IMPORT, hge_System_SetStateInt(hgeIntState state, INT value)
DECLARE CDECL IMPORT, hge_System_SetStateHwnd(hgeHwndState state, INT value)
DECLARE CDECL IMPORT, hge_System_Initiate(), INT
DECLARE CDECL IMPORT, hge_System_Start(), INT
DECLARE CDECL IMPORT, hge_System_Shutdown()
DECLARE CDECL IMPORT, hge_Release()
DECLARE CDECL IMPORT, hge_System_Log(string format)
DECLARE CDECL IMPORT, hge_System_Launch(string url),INT
DECLARE CDECL IMPORT, hge_System_Snapshot(string filename)
DECLARE CDECL IMPORT, hge_System_GetErrorMessage(),STRING
DECLARE CDECL IMPORT, hge_System_GetStateBool(hgeBoolState state),INT
DECLARE CDECL IMPORT, hge_System_GetStateFunc(hgeFuncState state), hgeCallback
DECLARE CDECL IMPORT, hge_System_GetStateHwnd(hgeHwndState  state), INT
DECLARE CDECL IMPORT, hge_System_GetStateInt(hgeIntState  state), INT
DECLARE CDECL IMPORT, hge_System_GetStateString(hgeStringState state), STRING


' INPUT FUNCTIONS
DECLARE CDECL IMPORT, hge_Input_GetKeyState(INT key), INT
DECLARE CDECL IMPORT, hge_Input_GetMousePos(float x BYREF, float y BYREF)
DECLARE CDECL IMPORT, hge_Input_SetMousePos(float x, float y)
DECLARE CDECL IMPORT, hge_Input_GetMouseWheel(), INT
DECLARE CDECL IMPORT, hge_Input_IsMouseOver(), INT
DECLARE CDECL IMPORT, hge_Input_KeyDown(INT key), INT
DECLARE CDECL IMPORT, hge_Input_KeyUp(INT key), INT
DECLARE CDECL IMPORT, hge_Input_GetKeyName(INT key), STRING
DECLARE CDECL IMPORT, hge_Input_GetKey(), INT
DECLARE CDECL IMPORT, hge_Input_GetChar(), INT
DECLARE CDECL IMPORT, hge_Input_GetEvent(hgeInputEvent event), INT


' RESOURCE FUNCTIONS
DECLARE CDECL IMPORT, hge_Resource_Load(string filename, uint size BYREF), INT
DECLARE CDECL IMPORT, hge_Resource_Free( INT res BYREF)
DECLARE CDECL IMPORT, hge_Resource_AttachPack(string filename, string password), INT
DECLARE CDECL IMPORT, hge_Resource_RemovePack(string filename)
DECLARE CDECL IMPORT, hge_Resource_RemoveAllPacks(), INT
DECLARE CDECL IMPORT, hge_Resource_MakePath(string filename), STRING
DECLARE CDECL IMPORT, hge_Resource_EnumFiles(string wildcard), STRING
DECLARE CDECL IMPORT, hge_Resource_EnumFolders(string wildcard), STRING


' INI FUNCTIONS
DECLARE CDECL IMPORT, hge_Ini_SetInt(string section, string name, int value)
DECLARE CDECL IMPORT, hge_Ini_GetInt(string section, string name, int defval), INT
DECLARE CDECL IMPORT, hge_Ini_SetFloat(string section, string name, float value)
DECLARE CDECL IMPORT, hge_Ini_GetFloat(string section, string name, float defval), float
DECLARE CDECL IMPORT, hge_Ini_SetString(string section, string name, string value)
DECLARE CDECL IMPORT, hge_Ini_GetString(string section, string name, string value)


' RANDOM FUNCTIONS
DECLARE CDECL IMPORT, hge_Random_Seed(int seed)
DECLARE CDECL IMPORT, hge_Random_Int(int min, int max), INT
DECLARE CDECL IMPORT, hge_Random_Float(float min, float max), float


' TIMER FUNCTIONS
DECLARE CDECL IMPORT, hge_Timer_GetTime(), float
DECLARE CDECL IMPORT, hge_Timer_GetDelta(), float
DECLARE CDECL IMPORT, hge_Timer_GetFPS(), INT


' GFX FUNCTIONS
DECLARE CDECL IMPORT, hge_Gfx_BeginScene(HTARGET target), INT
DECLARE CDECL IMPORT, hge_Gfx_EndScene()
DECLARE CDECL IMPORT, hge_Gfx_Clear(uint _color) ' _color in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_Gfx_RenderLine(float x1, float y1, float x2, float y2, uint colorn, float z)
DECLARE CDECL IMPORT, hge_Gfx_RenderTriple(hgeTriple triple)
DECLARE CDECL IMPORT, hge_Gfx_RenderQuad(hgeQuad quad)
DECLARE CDECL IMPORT, hge_Gfx_StartBatch(int prim_type, HTEXTURE tex, int blend, int max_prim BYREF), hgeVertex
DECLARE CDECL IMPORT, hge_Gfx_FinishBatch(int nprim)
DECLARE CDECL IMPORT, hge_Gfx_SetClipping(int x, int y, int w, int h)
DECLARE CDECL IMPORT, hge_Gfx_SetTransform(float x,float y,float dx,float dy,float rot,float hscale,float vscale)


' TARGET FUNCTIONS
DECLARE CDECL IMPORT, hge_Target_Create(int width, int height, INT zbuffer), HTARGET
DECLARE CDECL IMPORT, hge_Target_Free(HTARGET target)
DECLARE CDECL IMPORT, hge_Target_GetTexture(HTARGET target), HTEXTURE


' TEXTURE FUNCTIONS
DECLARE CDECL IMPORT, hge_Texture_Create(int width, int height), HTEXTURE
DECLARE CDECL IMPORT, hge_Texture_Load(string filename, uint size, INT bMipmap), HTEXTURE
DECLARE CDECL IMPORT, hge_Texture_Free(HTEXTURE tex)
DECLARE CDECL IMPORT, hge_Texture_GetWidth(HTEXTURE tex, OPT INT bOriginal), INT
DECLARE CDECL IMPORT, hge_Texture_GetHeight(HTEXTURE tex, OPT INT bOriginal), INT
DECLARE CDECL IMPORT, hge_Texture_Lock(HTEXTURE tex,INT bReadOnly,int left,int top,int width,int height), uint
DECLARE CDECL IMPORT, hge_Texture_Unlock(HTEXTURE tex)


' EFFECT FUNCTIONS
DECLARE CDECL IMPORT, hge_Effect_Load(string filename, uint size), HEFFECT
DECLARE CDECL IMPORT, hge_Effect_Free(HEFFECT eff)
DECLARE CDECL IMPORT, hge_Effect_Play(HEFFECT eff), HCHANNEL
DECLARE CDECL IMPORT, hge_Effect_PlayEx(HEFFECT eff, int volume, int pan, float pitch, INT loop), HCHANNEL
DECLARE CDECL IMPORT, hge_Music_Load(string filename, uint size), HMUSIC
DECLARE CDECL IMPORT, hge_Music_Free(HMUSIC mus)
DECLARE CDECL IMPORT, hge_Music_Play(HMUSIC mus, INT loop, int volume, int order, int row), HCHANNEL
DECLARE CDECL IMPORT, hge_Music_SetAmplification(HMUSIC music, int ampl)
DECLARE CDECL IMPORT, hge_Music_GetAmplification(HMUSIC music), INT
DECLARE CDECL IMPORT, hge_Music_GetLength(HMUSIC music), INT
DECLARE CDECL IMPORT, hge_Music_SetPos(HMUSIC music, int order, int row)
DECLARE CDECL IMPORT, hge_Music_GetPos(HMUSIC music, int order BYREF, int row BYREF), INT
DECLARE CDECL IMPORT, hge_Music_SetInstrVolume(HMUSIC music, int instrn, int volume)
DECLARE CDECL IMPORT, hge_Music_GetInstrVolume(HMUSIC music, int instrn), INT
DECLARE CDECL IMPORT, hge_Music_SetChannelVolume(HMUSIC music, int channel, int volume)
DECLARE CDECL IMPORT, hge_Music_GetChannelVolume(HMUSIC music, int channel), INT


' STREAM FUNCTIONS
DECLARE CDECL IMPORT, hge_Stream_Load(string filename, uint size), HSTREAM
DECLARE CDECL IMPORT, hge_Stream_Free(HSTREAM stream)
DECLARE CDECL IMPORT, hge_Stream_Play(HSTREAM stream, INT loop, int volume), HCHANNEL


' CHANNEL FUNCTIONS
DECLARE CDECL IMPORT, hge_Channel_SetPanning(HCHANNEL chn, int pan)
DECLARE CDECL IMPORT, hge_Channel_SetVolume(HCHANNEL chn, int volume)
DECLARE CDECL IMPORT, hge_Channel_SetPitch(HCHANNEL chn, float pitch)
DECLARE CDECL IMPORT, hge_Channel_Pause(HCHANNEL chn)
DECLARE CDECL IMPORT, hge_Channel_Resume(HCHANNEL chn)
DECLARE CDECL IMPORT, hge_Channel_Stop(HCHANNEL chn)
DECLARE CDECL IMPORT, hge_Channel_PauseAll()
DECLARE CDECL IMPORT, hge_Channel_ResumeAll()
DECLARE CDECL IMPORT, hge_Channel_StopAll()
DECLARE CDECL IMPORT, hge_Channel_IsPlaying(HCHANNEL chn), INT
DECLARE CDECL IMPORT, hge_Channel_GetLength(HCHANNEL chn), float
DECLARE CDECL IMPORT, hge_Channel_GetPos(HCHANNEL chn), float
DECLARE CDECL IMPORT, hge_Channel_SetPos(HCHANNEL chn, float fSeconds)
DECLARE CDECL IMPORT, hge_Channel_SlideTo(HCHANNEL channel,float time,int volume,int pan,float pitch)
DECLARE CDECL IMPORT, hge_Channel_IsSliding(HCHANNEL channel), INT

