
' USE THE IMPORT LIBRARY
$USE "ebhge.lib"


' SPRITE FUNCTIONS
DECLARE CDECL IMPORT, hge_Sprite_Create(HTEXTURE tex, float x, float y, float w, float h), HSPRITE
DECLARE CDECL IMPORT, hge_Sprite_Render(HSPRITE id, float x, float y)
DECLARE CDECL IMPORT, hge_Sprite_RenderEx(HSPRITE id, float x, float y, float rot, OPT float hscale=1.0, OPT float vscale=0.0)
DECLARE CDECL IMPORT, hge_Sprite_RenderStretch(HSPRITE id, float x, float y, float x2, float y2)
DECLARE CDECL IMPORT, hge_Sprite_Render4V(HSPRITE id, float x0, float y0, float x1, float y1, float x2, float y2, float x3, float y3)
DECLARE CDECL IMPORT, hge_Sprite_SetTexture(HSPRITE id, HTEXTURE tex)
DECLARE CDECL IMPORT, hge_Sprite_SetTextureRect(HSPRITE id, float x, float y, float w, float h, OPT INT adjSize=1 )
DECLARE CDECL IMPORT, hge_Sprite_SetColor(HSPRITE id, uint _color, OPT INT i=-1) '_color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_Sprite_SetZ(HSPRITE id, float z, OPT INT i=-1)
DECLARE CDECL IMPORT, hge_Sprite_SetBlendMode(HSPRITE id, int blend)
DECLARE CDECL IMPORT, hge_Sprite_SetFlip(HSPRITE id, int bX, int bY, OPT int bHotSpot=0)
DECLARE CDECL IMPORT, hge_Sprite_SetHotSpot(HSPRITE id, float x, float y)
DECLARE CDECL IMPORT, hge_Sprite_GetTexture(HSPRITE id), HTEXTURE
DECLARE CDECL IMPORT, hge_Sprite_GetTextureRect(HSPRITE id, float x BYREF, float y BYREF, float w BYREF, float h BYREF)
DECLARE CDECL IMPORT, hge_Sprite_GetColor(HSPRITE id, int i), uint 'return in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_Sprite_GetZ(HSPRITE id, int i), float
DECLARE CDECL IMPORT, hge_Sprite_GetBlendMode(HSPRITE id), INT
DECLARE CDECL IMPORT, hge_Sprite_GetHotSpot(HSPRITE id, float x BYREF, float y BYREF)
DECLARE CDECL IMPORT, hge_Sprite_GetFlip(HSPRITE id, int x BYREF, int y BYREF)
DECLARE CDECL IMPORT, hge_Sprite_GetWidth(HSPRITE id), float
DECLARE CDECL IMPORT, hge_Sprite_GetHeight(HSPRITE id), float
DECLARE CDECL IMPORT, hge_Sprite_GetBoundingBox(HSPRITE id, float x, float y, HRECT idrect)
DECLARE CDECL IMPORT, hge_Sprite_GetBoundingBoxEx(HSPRITE id, float x, float y, float rot, float hscale, float vscale,  HRECT idrect)
DECLARE CDECL IMPORT, hge_Sprite_Delete(HSPRITE id)

' ANIMATION FUNCTIONS
DECLARE CDECL IMPORT, hge_Animation_Create(HTEXTURE tex, int nframes, float FPS, float x, float y, float w, float h), HANIMATION
DECLARE CDECL IMPORT, hge_Animation_Play(HANIMATION id)
DECLARE CDECL IMPORT, hge_Animation_Stop(HANIMATION id)
DECLARE CDECL IMPORT, hge_Animation_Resume(HANIMATION id)
DECLARE CDECL IMPORT, hge_Animation_Update(HANIMATION id, float fDeltaTime)
DECLARE CDECL IMPORT, hge_Animation_IsPlaying(HANIMATION id), INT
DECLARE CDECL IMPORT, hge_Animation_SetTexture(HANIMATION id, HTEXTURE tex)
DECLARE CDECL IMPORT, hge_Animation_SetTextureRect(HANIMATION id, float x1, float y1, float x2, float y2)
DECLARE CDECL IMPORT, hge_Animation_SetMode(HANIMATION id, int mode)
DECLARE CDECL IMPORT, hge_Animation_SetSpeed(HANIMATION id, float FPS)
DECLARE CDECL IMPORT, hge_Animation_SetFrame(HANIMATION id, int n)
DECLARE CDECL IMPORT, hge_Animation_SetFrames(HANIMATION id, int n)
DECLARE CDECL IMPORT, hge_Animation_GetMode(HANIMATION id), INT
DECLARE CDECL IMPORT, hge_Animation_GetSpeed(HANIMATION id), float
DECLARE CDECL IMPORT, hge_Animation_GetFrame(HANIMATION id), INT
DECLARE CDECL IMPORT, hge_Animation_GetFrames(HANIMATION id), INT
DECLARE CDECL IMPORT, hge_Animation_Render(HANIMATION id, float x, float y)
DECLARE CDECL IMPORT, hge_Animation_RenderEx(HANIMATION id, float x, float y, float rot, OPT float hscale=1.0, OPT float vscale=0.0)
DECLARE CDECL IMPORT, hge_Animation_RenderStretch(HANIMATION id, float x1, float y1, float x2, float y2)
DECLARE CDECL IMPORT, hge_Animation_Render4V(HANIMATION id, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4)
DECLARE CDECL IMPORT, hge_Animation_Delete(HANIMATION id)

' FONT FUNCTIONS
DECLARE CDECL IMPORT, hge_Font_Create(string filename, OPT int bMipmap=0), HFONT
DECLARE CDECL IMPORT, hge_Font_Render(HFONT id, float x, float y, int align, string str)
DECLARE CDECL IMPORT, hge_Font_SetColor(HFONT id, uint _color)  '_color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_Font_SetZ(HFONT id, float z)
DECLARE CDECL IMPORT, hge_Font_SetBlendMode(HFONT id, int blend)
DECLARE CDECL IMPORT, hge_Font_SetScale(HFONT id, float scale)
DECLARE CDECL IMPORT, hge_Font_SetProportion(HFONT id, float prop)
DECLARE CDECL IMPORT, hge_Font_SetRotation(HFONT id, float rot)
DECLARE CDECL IMPORT, hge_Font_SetTracking(HFONT id, float tracking)
DECLARE CDECL IMPORT, hge_Font_SetSpacing(HFONT id, float spacing)
DECLARE CDECL IMPORT, hge_Font_GetColor(HFONT id), uint ' return in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_Font_GetZ(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetBlendMode(HFONT id), INT
DECLARE CDECL IMPORT, hge_Font_GetScale(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetProportion(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetRotation(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetTracking(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetSpacing(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetPreWidth(HFONT id, char chr), float
DECLARE CDECL IMPORT, hge_Font_GetPostWidth(HFONT id, char chr), float
DECLARE CDECL IMPORT, hge_Font_GetHeight(HFONT id), float
DECLARE CDECL IMPORT, hge_Font_GetStringWidth(HFONT id, string str, OPT int bMultiline=1), float
DECLARE CDECL IMPORT, hge_Font_GetSprite(HFONT id, char chr), HSPRITE ' this HSPRITE must not be initialized before with hge_Font_Create(...) and must not be deleted later
DECLARE CDECL IMPORT, hge_Font_Delete(HFONT id)

' PARTICLE SYSTEM FUNCTIONS
DECLARE CDECL IMPORT, hge_PartSys_Create(string filename, HSPRITE idsprite), HPARTSYS
DECLARE CDECL IMPORT, hge_PartSys_Fire(HPARTSYS id)
DECLARE CDECL IMPORT, hge_PartSys_FireAt(HPARTSYS id, float x, float y)
DECLARE CDECL IMPORT, hge_PartSys_Render(HPARTSYS id)
DECLARE CDECL IMPORT, hge_PartSys_Stop(HPARTSYS id, OPT int bKillParticles=0)
DECLARE CDECL IMPORT, hge_PartSys_Update(HPARTSYS id, float fDeltaTime)
DECLARE CDECL IMPORT, hge_PartSys_MoveTo(HPARTSYS id, float x, float y, OPT int bMoveParticles=0)
DECLARE CDECL IMPORT, hge_PartSys_Transpose(HPARTSYS id, float x, float y)
DECLARE CDECL IMPORT, hge_PartSys_SetScale(HPARTSYS id, float scale)
DECLARE CDECL IMPORT, hge_PartSys_SetEmission(HPARTSYS id, int Emission)
DECLARE CDECL IMPORT, hge_PartSys_TrackBoundingBox(HPARTSYS id, int bTrack)
DECLARE CDECL IMPORT, hge_PartSys_GetParticlesAlive(HPARTSYS id), INT
DECLARE CDECL IMPORT, hge_PartSys_GetAge(HPARTSYS id), float
DECLARE CDECL IMPORT, hge_PartSys_GetPosition(HPARTSYS id, float x BYREF, float y BYREF)
DECLARE CDECL IMPORT, hge_PartSys_GetTransposition(HPARTSYS id, float x BYREF, float y BYREF)
DECLARE CDECL IMPORT, hge_PartSys_GetScale(HPARTSYS id), float
DECLARE CDECL IMPORT, hge_PartSys_GetBoundingBox(HPARTSYS id, HRECT idrect), INT
DECLARE CDECL IMPORT, hge_PartSys_Delete(HPARTSYS id)

' DISTORTION MESH
DECLARE CDECL IMPORT, hge_DistortionMesh_Create(int cols, int rows), HDISTMESH
DECLARE CDECL IMPORT, hge_DistortionMesh_Render(HDISTMESH id, float x, float y)
DECLARE CDECL IMPORT, hge_DistortionMesh_Clear(HDISTMESH id, OPT uint _color=0xFFFFFFFF, OPT float z=0.5) '_color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_DistortionMesh_SetTexture(HDISTMESH id, HTEXTURE tex)
DECLARE CDECL IMPORT, hge_DistortionMesh_SetTextureRect(HDISTMESH id, float x, float y, float w, float h)
DECLARE CDECL IMPORT, hge_DistortionMesh_SetBlendMode(HDISTMESH id, int blend)
DECLARE CDECL IMPORT, hge_DistortionMesh_SetZ(HDISTMESH id, int col, int row, float z)
DECLARE CDECL IMPORT, hge_DistortionMesh_SetColor(HDISTMESH id, int col, int row, uint _color) '_color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_DistortionMesh_SetDisplacement(HDISTMESH id, int col, int row, float dx, float dy, int ref)
DECLARE CDECL IMPORT, hge_DistortionMesh_GetTexture(HDISTMESH id), HTEXTURE
DECLARE CDECL IMPORT, hge_DistortionMesh_GetTextureRect(HDISTMESH id, float x BYREF, float y BYREF, float w BYREF, float h BYREF)
DECLARE CDECL IMPORT, hge_DistortionMesh_GetBlendMode(HDISTMESH id), INT
DECLARE CDECL IMPORT, hge_DistortionMesh_GetZ(HDISTMESH id, int col, int row), float
DECLARE CDECL IMPORT, hge_DistortionMesh_GetColor(HDISTMESH id, int col, int row), uint 'return in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_DistortionMesh_GetDisplacement(HDISTMESH id, int col, int row, float dx BYREF, float dy BYREF, int ref)
DECLARE CDECL IMPORT, hge_DistortionMesh_GetRows(HDISTMESH id), INT
DECLARE CDECL IMPORT, hge_DistortionMesh_GetCols(HDISTMESH id), INT
DECLARE CDECL IMPORT, hge_DistortionMesh_Delete(HDISTMESH id)

' RECT FUNCTIONS
DECLARE CDECL IMPORT, hge_Rect_Create(float x1, float y1, float x2, float y2), HRECT
DECLARE CDECL IMPORT, hge_Rect_Clear(HRECT id)
DECLARE CDECL IMPORT, hge_Rect_IsClean(HRECT id), INT
DECLARE CDECL IMPORT, hge_Rect_Set(HRECT id, float x1, float y1, float x2, float y2)
DECLARE CDECL IMPORT, hge_Rect_Get(HRECT id, float x1 BYREF, float y1 BYREF, float x2 BYREF, float y2 BYREF)
DECLARE CDECL IMPORT, hge_Rect_SetRadius(HRECT id, float x, float y, float r)
DECLARE CDECL IMPORT, hge_Rect_Encapsulate(HRECT id, float x, float y)
DECLARE CDECL IMPORT, hge_Rect_TestPoint(HRECT id, float x, float y), INT
DECLARE CDECL IMPORT, hge_Rect_Intersect(HRECT id, HRECT idother), INT
DECLARE CDECL IMPORT, hge_Rect_Delete(HRECT id)

' VECTOR FUNCTIONS
DECLARE CDECL IMPORT, hge_Vector_Create(float x, float y), HVECTOR
DECLARE CDECL IMPORT, hge_Vector_Dot(HVECTOR id, HVECTOR idvector), float
DECLARE CDECL IMPORT, hge_Vector_Length(HVECTOR id), float
DECLARE CDECL IMPORT, hge_Vector_Angle(HVECTOR id, HVECTOR idvector), float
DECLARE CDECL IMPORT, hge_Vector_Clamp(HVECTOR id, float max)
DECLARE CDECL IMPORT, hge_Vector_Normalize(HVECTOR id)
DECLARE CDECL IMPORT, hge_Vector_Rotate(HVECTOR id, float a)
DECLARE CDECL IMPORT, hge_Vector_SetComponents(HVECTOR id, float x, float y)
DECLARE CDECL IMPORT, hge_Vector_GetComponents(HVECTOR id, float x BYREF, float y BYREF)
DECLARE CDECL IMPORT, hge_Vector_Add(HVECTOR id, HVECTOR idvector)
DECLARE CDECL IMPORT, hge_Vector_Subtract(HVECTOR id, HVECTOR idvector)
DECLARE CDECL IMPORT, hge_Vector_Delete(HVECTOR id)

' COLOR RGB FUNCTIONS
DECLARE CDECL IMPORT, hge_ColorRGB_Create(float alpha, float red, float green, float blue), HCOLORRGB
DECLARE CDECL IMPORT, hge_ColorRGB_SetColor(HCOLORRGB col, uint _color) ' _color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_ColorRGB_GetColor(HCOLORRGB col), uint ' return color in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_ColorRGB_SetComponents(HCOLORRGB col, float alpha, float red, float green, float blue) ' each component from 0 to 1
DECLARE CDECL IMPORT, hge_ColorRGB_GetComponents(HCOLORRGB col, float alpha BYREF, float red BYREF, float green BYREF, float blue BYREF)
DECLARE CDECL IMPORT, hge_ColorRGB_Clamp(HCOLORRGB col)
DECLARE CDECL IMPORT, hge_ColorRGB_Delete(HCOLORRGB col)

' COLOR HSV FUNCTIONS
DECLARE CDECL IMPORT, hge_ColorHSV_Create(float alpha, float hue, float sat, float value), HCOLORHSV
DECLARE CDECL IMPORT, hge_ColorHSV_SetColor(HCOLORHSV col, uint _color) ' _color: in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_ColorHSV_GetColor(HCOLORHSV col), uint ' return color in format 0xAARRGGBB
DECLARE CDECL IMPORT, hge_ColorHSV_SetComponents(HCOLORHSV col, float alpha, float hue, float sat, float value) ' each component from 0 to 1
DECLARE CDECL IMPORT, hge_ColorHSV_GetComponents(HCOLORHSV col, float alpha BYREF, float hue BYREF, float sat BYREF, float value BYREF)
DECLARE CDECL IMPORT, hge_ColorHSV_Clamp(HCOLORHSV col)
DECLARE CDECL IMPORT, hge_ColorHSV_Delete(HCOLORHSV col)
